#// File    : BC31TV2.MAK
#// Author  : Eric Woodruff,  CIS ID: 72134,1150
#// Updated : Thu 08/25/94 11:16:11
#//
#
# Flags for makefile:
#
#     -DCPU286       Build library for 80286 (DPMI16) CPUFLAG = -2
#                    If undefined, then compile for 8088 CPUFLAG = -1- -2-
#
#     -DOVERLAY      Build overlayable libraries (TVO.LIB/TVNO.LIB).
#                    If not specified, non-overlay libraries are built
#                    (TV.LIB/TVADD.LIB)
#
#     -DALIGNMENT=2  Word (=2) or dword (=4) aligned library.
#     -DALIGNMENT=4
#
#     -DBCROOT=...   Specifies the path where you installed the compiler
#
#     -DTVDIR=...    Specifies the path where you installed TVISION
#

.autodepend
.swap

!if !$d(BCROOT)
BCROOT = $(MAKEDIR)\..
!endif

!if !$d(TVDIR)
TVDIR = $(BCROOT)
!endif

!if !$d(SRCDIR)
SRCDIR = $(TVDIR)\SOURCE\TVISION
!endif

!if $d(CPU286)
CPUFLAG = -2
!else
CPUFLAG = -1- -2-
!endif

!if !$d(OVERLAY)
LIBNAME  = TV.LIB
LIBNAME2 = TVADD.LIB
CFGNAME  = TV.CFG
OBJDIR   = $(SRCDIR)\OBJS
CCOVYFLAGS =
AOVYFLAGS  =
!else
LIBNAME  = TVO.LIB
LIBNAME2 = TVNO.LIB
CFGNAME  = TVO.CFG
OBJDIR   = $(SRCDIR)\OBJSOVY
CCOVYFLAGS = -Y -Vs -Vb -B
AOVYFLAGS  = /o
!endif

INCNAME = TVWRITE.INC
GENEXE  = GENINC.EXE
GENOBJ  = GENINC.OBJ
GENSRC  = GENINC.CPP

CC      = BCC
ASM     = TASM
LIB     = TLIB
LINK    = TLINK

!if "$(BCROOT)"=="$(TVDIR)"
INCLUDE  = $(BCROOT)\INCLUDE
LIBDIR   = $(BCROOT)\LIB
!else
INCLUDE  = $(TVDIR)\INCLUDE;$(BCROOT)\INCLUDE
LIBDIR   = $(TVDIR)\LIB;$(BCROOT)\LIB
!endif

TVLIBDIR = $(TVDIR)\LIB

LIBFLAGS   = /0
CDEBUGFLAG = -DNDEBUG
ADEBUGFLAG = /zn

.path.obj = $(OBJDIR)

!if $d(ALIGNMENT)
ALIGNFLAG = -a$(ALIGNMENT)
!else
ALIGNFLAG =
!endif

CFLAGS1 = -ml -h -Oe -Os -O -Ob -Ol -b -Z -ff -k- -N- -G- -v- -w -w-amp -P
CFLAGS2 = -n$(OBJDIR) $(CDEBUGFLAG) $(ALIGNFLAG) $(CCOVYFLAGS) \
          $(CPUFLAG) -I$(INCLUDE)
AFLAGS  = /m2 /ml /q /w2 $(ADEBUGFLAG) $(AOVYFLAGS) /DBC31

# Not used by the default TV 2.0 source code, but someone may finish it.
!if $d(NO_STREAMABLE)
CFLAGS1 = $(CFLAGS1) -DNO_STREAMABLE
!endif

OBJS = COLORSEL.OBJ \
       DRIVERS.OBJ  \
       DRIVERS2.OBJ \
       EDITS.OBJ    \
       EDITSTAT.OBJ \
       FRAMELIN.OBJ \
       GRP.OBJ      \
       HARDWARE.OBJ \
       HARDWRVR.OBJ \
       HELP.OBJ     \
       HELPBASE.OBJ \
       HISTLIST.OBJ \
       MAPCOLOR.OBJ \
       MENU.OBJ     \
       MISC.OBJ     \
       MSGBOX.OBJ   \
       NEW.OBJ      \
       NEWSTR.OBJ   \
       NMBKGRND.OBJ \
       NMBUTTON.OBJ \
       NMCHDRDL.OBJ \
       NMCHKBOX.OBJ \
       NMCLRSEL.OBJ \
       NMCLUSTR.OBJ \
       NMCOLLCT.OBJ \
       NMDIALOG.OBJ \
       NMDIRBOX.OBJ \
       NMDIRCOL.OBJ \
       NMDSKTOP.OBJ \
       NMEDITOR.OBJ \
       NMFILCOL.OBJ \
       NMFILDLG.OBJ \
       NMFILLST.OBJ \
       NMFRAME.OBJ  \
       NMGROUP.OBJ  \
       NMHIST.OBJ   \
       NMINPTLN.OBJ \
       NMLABEL.OBJ  \
       NMLSTBOX.OBJ \
       NMLSTVWR.OBJ \
       NMMNUBAR.OBJ \
       NMMNUBOX.OBJ \
       NMMNUVW.OBJ  \
       NMMULCHK.OBJ \
       NMOUTLIN.OBJ \
       NMPRMTXT.OBJ \
       NMRBTNS.OBJ  \
       NMRESCOL.OBJ \
       NMSCOLL.OBJ  \
       NMSCRBAR.OBJ \
       NMSCROLL.OBJ \
       NMSTCTXT.OBJ \
       NMSTDDLG.OBJ \
       NMSTLINE.OBJ \
       NMSTRCOL.OBJ \
       NMSTRLST.OBJ \
       NMVALIDA.OBJ \
       NMVIEW.OBJ   \
       NMWINDOW.OBJ \
       PALETTE.OBJ  \
       SBKGRND.OBJ  \
       SBUTTON.OBJ  \
       SCHDRDLG.OBJ \
       SCHECKBO.OBJ \
       SCLRSEL.OBJ  \
       SCLUSTER.OBJ \
       SDESKTOP.OBJ \
       SDIALOG.OBJ  \
       SDIRCOLL.OBJ \
       SDIRLIST.OBJ \
       SEDITORS.OBJ \
       SFILCOLL.OBJ \
       SFILDLG.OBJ  \
       SFILELST.OBJ \
       SFINFPNE.OBJ \
       SFINPUTL.OBJ \
       SFRAME.OBJ   \
       SGROUP.OBJ   \
       SHISTORY.OBJ \
       SINPUTLI.OBJ \
       SLABEL.OBJ   \
       SLISTBOX.OBJ \
       SLSTVIEW.OBJ \
       SMENUBAR.OBJ \
       SMENUBOX.OBJ \
       SMNUVIEW.OBJ \
       SMULCHKB.OBJ \
       SOUTLINE.OBJ \
       SPARAMTE.OBJ \
       SRADIOBU.OBJ \
       SRESCOLL.OBJ \
       SSCRLBAR.OBJ \
       SSCROLLE.OBJ \
       SSTATICT.OBJ \
       SSTATUSL.OBJ \
       SSTRCOLL.OBJ \
       SSTRLST.OBJ  \
       STDDLG.OBJ   \
       STRMSTAT.OBJ \
       SVALID.OBJ   \
       SVIEW.OBJ    \
       SWAPST.OBJ   \
       SWINDOW.OBJ  \
       SYSERR.OBJ   \
       SYSINT.OBJ   \
       TAPPLICA.OBJ \
       TBKGRND.OBJ  \
       TBUTTON.OBJ  \
       TCHDRDLG.OBJ \
       TCHECKBO.OBJ \
       TCLUSTER.OBJ \
       TCMDSET.OBJ  \
       TCOLLECT.OBJ \
       TDESKTOP.OBJ \
       TDIALOG.OBJ  \
       TDIRCOLL.OBJ \
       TDIRLIST.OBJ \
       TEDITOR1.OBJ \
       TEDITOR2.OBJ \
       TEDITWND.OBJ \
       TEVENT.OBJ   \
       TEXTVIEW.OBJ \
       TFILDLG.OBJ  \
       TFILECOL.OBJ \
       TFILEDTR.OBJ \
       TFILLIST.OBJ \
       TFRAME.OBJ   \
       TGRMV.OBJ    \
       TGROUP.OBJ   \
       THISTORY.OBJ \
       THISTWIN.OBJ \
       THSTVIEW.OBJ \
       TINDICTR.OBJ \
       TINPUTLI.OBJ \
       TLABEL.OBJ   \
       TLISTBOX.OBJ \
       TLSTVIEW.OBJ \
       TMEMO.OBJ    \
       TMENUBAR.OBJ \
       TMENUBOX.OBJ \
       TMNUVIEW.OBJ \
       TMOUSE.OBJ   \
       TMULCHKB.OBJ \
       TOBJECT.OBJ  \
       TOBJSTRM.OBJ \
       TOUTLINE.OBJ \
       TPARAMTE.OBJ \
       TPOINT.OBJ   \
       TPROGRAM.OBJ \
       TRADIOBU.OBJ \
       TRESCOLL.OBJ \
       TRESFILE.OBJ \
       TSCREEN.OBJ  \
       TSCRLBAR.OBJ \
       TSCROLLE.OBJ \
       TSORTCOL.OBJ \
       TSTATICT.OBJ \
       TSTATUSL.OBJ \
       TSTRCOLL.OBJ \
       TSTRLIST.OBJ \
       TTPRVLNS.OBJ \
       TVALIDAT.OBJ \
       TVCURSOR.OBJ \
       TVEXPOSD.OBJ \
       TVIEW.OBJ    \
       TVTEXT1.OBJ  \
       TVTEXT2.OBJ  \
       TVWRITE.OBJ  \
       TWINDOW.OBJ

.cpp.obj:
     $(CC) -c +$(CFGNAME) {$. }

.asm.obj:
     $(ASM) $(AFLAGS) $&.ASM, $(OBJDIR)\$&.OBJ

all: $(CFGNAME) dirs $(TVLIBDIR)\$(LIBNAME)
    DEL $(CFGNAME)

dirs:
    IF NOT EXIST $(OBJDIR) MD $(OBJDIR)

$(CFGNAME):
    ECHO $(CFLAGS1) > $(CFGNAME)
    ECHO $(CFLAGS2) >> $(CFGNAME)

# These need special handling in BC++ 3.1 with overlay support.
!if $d(OVERLAY)
sysint.obj : sysint.asm
     $(ASM) /m2 /ml /q /w2 /zn $&.asm, $(OBJDIR)\$&.obj

tevent.obj : tevent.cpp
     $(CC) -c +$(CFGNAME) -Y- -k $&.cpp
!endif

*.asm: $(INCNAME)

$(INCNAME): $(GENEXE)
     $(GENEXE) > $(INCNAME)

$(GENEXE): $(OBJDIR)\$(GENOBJ)
     $(CC) +$(CFGNAME) -f- -e$(GENEXE) -L$(LIBDIR) -n. $(OBJDIR)\$(GENOBJ)

$(OBJDIR)\$(GENOBJ): $(GENSRC)
     $(CC) +$(CFGNAME) -f- -c -o$(OBJDIR)\$(GENOBJ) $(GENSRC)

$(TVLIBDIR)\$(LIBNAME): $(OBJS) $(OBJS2)
     @if exist $(TVLIBDIR)\$(LIBNAME) del $(TVLIBDIR)\$(LIBNAME)
     @if exist $(TVLIBDIR)\$(LIBNAME2) del $(TVLIBDIR)\$(LIBNAME2)
     @cd $(OBJDIR)
     $(LIB) $(LIBFLAGS) $(TVLIBDIR)\$(LIBNAME) @$(SRCDIR)\TVLIB.RSP
     $(LIB) $(LIBFLAGS) $(TVLIBDIR)\$(LIBNAME2) @$(SRCDIR)\TVLIB2.RSP
     @cd $(SRCDIR)

clean:
     del $(OBJDIR)\*.obj

# End of BC++ 3.1 and Turbo Vision 2.0 Makefile!
